<?php
/*
Plugin Name:  Express Partage Facebook Button 
Plugin URI: http://www.share-express.com/fbexppar/
Description: Partage Facebook, personnalisé.
Version: 1.3
Author: Multi-Vision International 
Author URI: http://www.multi-vision.biz/
*/



if ( !defined('WP_CONTENT_URL') ) {
	define('FBEXPPAR_URL',get_option('siteurl').'/wp-content/plugins/'.plugin_basename(dirname(__FILE__)).'/');
} else {
	define('FBEXPPAR_URL',WP_CONTENT_URL.'/plugins/'.plugin_basename(dirname(__FILE__)).'/');
}

register_activation_hook(__FILE__, array('fbexppar','plugin_activation'));
register_deactivation_hook(__FILE__, array('fbexppar','plugin_deactivation'));
register_uninstall_hook(__FILE__, array('fbexppar','plugin_uninstall'));

add_action('init', array('fbexppar', 'init'));



class fbexppar{
	
	const LANG_DIR = '/lang/'; // Defaut lang dirctory
	
	/**
	 * 
	 * The main 'loader'
	 */
	function init() {

		//Setup the translation
		load_plugin_textdomain('fbexppar',false, dirname(plugin_basename( __FILE__ ) ) . self::LANG_DIR);
		
    	// admin actions and hooks
        if (is_admin()) {
            self::admin_hooks();
        }
		add_filter('the_content', array('fbexppar','fb_share'));
    }
    
    /**
     * 
     * The admin hooks
     */
    public static function admin_hooks(){
		
    	add_action('admin_menu', array('fbexppar', 'admin_menu'));
		
    	
    	//Add schedules for wp_cron
    	add_filter('cron_schedules', array('fbexppar','custom_cron_schedules'));
    	
    	//Javascript
    	/* /
        if (isset($_GET['page']) && $_GET['page'] == 'fbexppar_settings') {
	    	wp_enqueue_script('jquery-ui-datepicker', plugins_url('/js/jquery.ui.datepicker.min.js',__FILE__), array('jquery', 'jquery-ui-core') );
			wp_enqueue_script('twitterfavs-admin-js', plugins_url('/js/admin.js',__FILE__), array('jquery-ui-datepicker') );
			
			//Smoothness style
			wp_enqueue_style('jquery.ui.smoothness', plugins_url('/css/smoothness/jquery-ui-1.8.17.custom.css',__FILE__));
		}
		/* */
    	
    }
    
    /**
     * 
     * Set up the admin menu(s)
     */
    public static function admin_menu(){
    	//add_options_page("Express Partage FB plugin admin page", __("Express Partage FB",'fbexppar'), 'manage_options', 'fbexppar_settings', array('fbexppar', "admin_settings"));
		add_menu_page('Express Partage FB plugin admin page', "Express Partage FB", 8, basename(__FILE__),   array('fbexppar', "admin_settings"));
		add_submenu_page(basename(__FILE__), 'Parametrage', 'Parametrage', 8, basename(__FILE__), array('fbexppar', "admin_settings"));
		add_submenu_page(basename(__FILE__), 'statistiques', 'statistiques', 8, basename(__FILE__) . 'stats', array('fbexppar', 'admin_stat'));
    }
	
    /**
	*
	* Save option
	*/
	public static function admin_setting_update() {
	
		// nonce check
		if ( !wp_verify_nonce( $_POST['_wpnonce'], plugin_basename( __FILE__ ) ) ) return;
	
		$updated = false;
		if (isset($_POST['plugin_ok'])) {
			self::update_option('my_plugin_btname', $_POST['my_plugin_btname']);
			self::update_option('my_plugin_btposition', $_POST['my_plugin_btposition']);
			self::update_option('my_plugin_btpositiongd', $_POST['my_plugin_btpositiongd']);
			self::update_option('my_plugin_btorientation', $_POST['my_plugin_btorientation']);
			self::update_option('my_plugin_bttype', $_POST['my_plugin_bttype']);
			
			
			$updated = true;
		}
	
		if ($updated) {
			echo '<div id="message" class="updated fade">';
			echo '<p>'.__('Settings successfully updated.', 'fbexppar').'</p>';
			echo '</div>';
		} else {
			echo '<div id="message" class="error fade">';
			echo '<p>'.__('Unable to update settings.', 'fbexppar').'</p>';
			echo '</div>';
		}
	}
    /**
     * 
     * The admin settings page
     */
    public static function admin_settings(){
		?>

<div class="wrap">
  <div id="icon-options-general" class="icon32"></div>
  <h2>
    <?php _e('WordPress Express Partage FB plugin','fbexppar') ?>
  </h2>
  <?php if (isset($_POST['plugin_ok'])) {
			self::admin_setting_update(); // update setting
	} ?>
  <form action="" method="post">
    <table class="form-table">
      <tbody>
        <tr valign="top">
          <th scope="row"> <label for="my_plugin_btname">
              <?php _e('Nom du bouton','fbexppar') ?>
            </label>
            </th>
          <td><input type="text" name="my_plugin_btname" id="my_plugin_btname" value="<?php esc_attr_e( self::get_option('my_plugin_btname' )); ?>" /></td>
        </tr>
        
        <tr valign="top">
          <th scope="row"> <label for="my_plugin_bttype">
              <?php _e('Type','fbexppar') ?>
            </label>
           
            </th>
          <td align="left">
          <table width="50%" align="left" background="0" cellpadding="0" cellspacing="0" >
          <tr>
          <td valign="bottom">
          <img src="<?php echo FBEXPPAR_URL;?>/images/stylec.png" ><br>
          <input type="radio" name="my_plugin_bttype" id="my_plugin_bttype" value="0" <?php if (self::get_option('my_plugin_bttype') == '0') echo 'checked="checked"'; ?> />
           <label for="fb_include_counter">Lien</label>
           </td>
           <td valign="bottom">
            <img src="<?php echo FBEXPPAR_URL;?>/images/stylel.png" ><br />
          <input type="radio" name="my_plugin_bttype" id="my_plugin_bttype" value="1" <?php if (self::get_option('my_plugin_bttype') == '1') echo 'checked="checked"'; ?> />
          <label for="fb_include_counter">Bouton</label><br />
            </td>
          </tr>
          </table>
         </td>
         </tr> 
        
        <tr valign="top">
          <th scope="row"> <label for="my_plugin_btposition">
              <?php _e('Orientation du text','fbexppar') ?>
            </label>
           
            </th>
          <td>
          
          <input type="radio" name="my_plugin_btorientation" id="my_plugin_btorientation" value="0" <?php if (self::get_option('my_plugin_btorientation') == '0') echo 'checked="checked"'; ?> />
           <label for="fb_include_counter">De gauche à droite (fr)</label>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
           
          
          <input type="radio" name="my_plugin_btorientation" id="my_plugin_btorientation" value="1" <?php if (self::get_option('my_plugin_btorientation') == '1') echo 'checked="checked"'; ?> />
          <label for="fb_include_counter">De droite à gauche (ar)</label><br />
        
          
         </td>
         </tr> 
        
        <tr valign="top">
          <th scope="row"> <label for="my_plugin_btposition">
              <?php _e('Position du bouton','fbexppar') ?>
            </label>
           
            </th>
          <td>
          <input type="radio" name="my_plugin_btposition" id="my_plugin_btposition" value="0" <?php if (self::get_option('my_plugin_btposition') == '0') echo 'checked="checked"'; ?> />
          <label for="fb_include_counter">En haut</label><br />
          <input type="radio" name="my_plugin_btposition" id="my_plugin_btposition" value="1" <?php if (self::get_option('my_plugin_btposition') == '1') echo 'checked="checked"'; ?> />
          <label for="fb_include_counter">En bas</label><br />
             <input type="radio" name="my_plugin_btposition" id="my_plugin_btposition" value="2" <?php if (self::get_option('my_plugin_btposition') == '2') echo 'checked="checked"'; ?> />
          <label for="fb_include_counter">En haut et bas</label><br />
          <input type="radio" name="my_plugin_btposition" id="my_plugin_btposition" value="3" <?php if (self::get_option('my_plugin_btposition') == '3') echo 'checked="checked"'; ?> />
          <label for="fb_include_counter">Manuel : insérer [FBEXPPAR] à l’endroit voulu</label><br />
          <br />
          <input type="radio" name="my_plugin_btpositiongd" id="my_plugin_btpositiongd" value="0" <?php if (self::get_option('my_plugin_btpositiongd') == '0') echo 'checked="checked"'; ?> />
          <label for="fb_include_counter">A Droite</label>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
          <input type="radio" name="my_plugin_btpositiongd" id="my_plugin_btpositiongd" value="1" <?php if (self::get_option('my_plugin_btpositiongd') == '1') echo 'checked="checked"'; ?> />
          <label for="fb_include_counter">A gauche</label><br />
          
          </td>
        </tr>
        
      </tbody>
    </table>
    <p class="submit">
      <input type="submit" class="button-primary" name="plugin_ok" value="<?php esc_attr_e('Save settings','fbexppar') ?>" />
    </p>
    <?php // Use nonce for verification
wp_nonce_field( plugin_basename( __FILE__ ), '_wpnonce' );?>
  </form>
</div>
<?php
		
    }
    
	/**
	 * 
	 * Get a plugin's specific option
	 * @param string $option_name
	 */
    public static function get_option($option_name){
    	return get_option('fbexppar_'.$option_name);
    }
    
    /**
     * 
     * Set a plugin's specific option
     * @param unknown_type $option_name
     */
	public static function update_option($option_name,$option_value){
    	return update_option('fbexppar_'.$option_name,$option_value);
    }
    
	/**
     * 
     * Delete a plugin's specific option
     * @param string $option_name
     */
    public static function delete_option($option_name){
    	return delete_option('fbexppar_'.$option_name);
    }
    
    /**
     * 
     * Usually, here, we set-up database tables or default options

     */
	public static function fb_share($content)
	{
		if (is_single())
		{
			//wp_enqueue_style('my-style', plugins_url('style.css', __FILE__) );
			if (get_post_status($post->ID) == 'publish') {
				$url = get_permalink();
			}
			
			$nbpartage='';
			$share_count		=0;
			$like_count			=0;
			$comment_count		=0;
			$query_facebook="http://api.facebook.com/restserver.php?method=links.getStats&urls=".$url;
			if ($dom = DomDocument::load($query_facebook))
			{
				$liste_nb = $dom->getElementsByTagName('total_count');
				if ($liste_nb->length>0 )
				{
					$nbpartage=$liste_nb->item(0)->nodeValue;
				}
				
				$liste_nb = $dom->getElementsByTagName('share_count');
				if ($liste_nb->length>0 )
				{
					$share_count=intval($liste_nb->item(0)->nodeValue);
				}
				
				$liste_nb = $dom->getElementsByTagName('like_count');
				if ($liste_nb->length>0 )
				{
					$like_count=intval($liste_nb->item(0)->nodeValue);
				}
				
				$liste_nb = $dom->getElementsByTagName('comment_count');
				if ($liste_nb->length>0 )
				{
					$comment_count=intval($liste_nb->item(0)->nodeValue);
				}
				
				
				
			}
			

			
			
		 	$thumb="";
			$thumburl ="";
			$txtshare="";
			$titleshare="";
			 	
			$thepost = get_post(get_the_ID()); 
			if ( has_post_thumbnail() ) 
			{
				$thumb = wp_get_attachment_image_src( get_post_thumbnail_id($thepost->ID), 'full' ); 
				$thumburl = $thumb['0'];
			}
			else
			{
				$output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $thepost->post_content, $matches);
			  	$thumburl = $matches [1] [0];
			}
			
			if (trim($thepost->post_excerpt)=="")
			{
				$txtshare=$thepost->post_content;
				$pieces = explode("<!--more-->",$txtshare);
  			 	$txtshare=$pieces[0];
				$txtshare=trim(strip_tags($txtshare));
				/*if (strlen($txtshare)>300)
				{
					$txtshare= substr($txtshare,0,200)." ...";
				}
				*/
				$txtshare=str_replace('[FBEXPPAR]', '', $txtshare);
				$txtshare=urlencode($txtshare);
				
			}
			else 
			{	
				$txtshare=str_replace('[FBEXPPAR]', '', $thepost->post_excerpt);
				$txtshare= urlencode( $txtshare); 
			}
			$titleshare=$thepost->post_title;
			$btpositiongd="right";
			
			
			if  (self::get_option('my_plugin_btpositiongd' )==1) $btpositiongd="left";
			
		   
		   $tab_button=array(
		   'url'=>$url,
		   'image'=>$thumburl,
		   'title'=>$titleshare,
		   'summary'=>$txtshare,
		   'btpositiongd'=>$btpositiongd,
		   'my_plugin_btorientation'=>self::get_option('my_plugin_btorientation'),
		   'my_plugin_bttype'=>self::get_option('my_plugin_bttype'),
		   'my_plugin_btname'=>self::get_option('my_plugin_btname' ),
		   'nbpartage'=>$nbpartage,
		   'path_plugin'=>FBEXPPAR_URL);
		   
		   
		   
		   
   		   $button=urlencode(base64_encode(serialize($tab_button)));
		 
           $button='<iframe src="'.plugins_url('ifbecppar.php', __FILE__).'?b='.$button.'" width="100" height="50" frameborder="0" scrolling="no" allowtransparency="true" style="float: '.$btpositiongd.';"></iframe>';
		  
		   
		   if (self::get_option('my_plugin_btposition' )==0) 
		   		{
					self::save_FBEXPPAR_stat($thepost->ID,$url,$share_count,$like_count,$comment_count);
		   			return $button .'<br>'. str_replace('[FBEXPPAR]', '', $content) ;
				}
		   else 
				if (self::get_option('my_plugin_btposition' )==1) 
					{
						self::save_FBEXPPAR_stat($thepost->ID,$url,$share_count,$like_count,$comment_count);
						return  str_replace('[FBEXPPAR]', '', $content) .'<br>'. $button;
					}
				elseif (self::get_option('my_plugin_btposition' )==2) 
					{
						self::save_FBEXPPAR_stat($thepost->ID,$url,$share_count,$like_count,$comment_count);
						return $button .'<br>'. str_replace('[FBEXPPAR]', '', $content) .'<br>'. $button;
					}
				elseif (self::get_option('my_plugin_btposition' )==3) 
					{
						self::save_FBEXPPAR_stat($thepost->ID,$url,$share_count,$like_count,$comment_count);
						return str_replace('[FBEXPPAR]', $button, $content);
					}
				else  return  str_replace('[FBEXPPAR]', '', $content);
		}
		else  return  str_replace('[FBEXPPAR]', '', $content);
		
	} 
    public static function plugin_activation(){
    	//Do nice things
		global $wpdb;
		self::update_option('my_plugin_btname','Partager');
		self::update_option('my_plugin_btposition','0');
		self::update_option('my_plugin_btpositiongd', '0');
		self::update_option('my_plugin_btorientation', '0');
		self::update_option('my_plugin_bttype', '0');
		
		
		$table_name = $wpdb->prefix . "FBEXPPAR_stat";
		$sql = "CREATE TABLE $table_name (
		  id mediumint(9) NOT NULL AUTO_INCREMENT,
		  post_id bigint(20) DEFAULT 0 NOT NULL,
		  url VARCHAR(400) DEFAULT '' NOT NULL,
		  shares int(11)  DEFAULT 0 NOT NULL,
		  likes int(11)  DEFAULT 0 NOT NULL,
		  comments int(11)  DEFAULT 0 NOT NULL,
		  total_count int(11)  DEFAULT 0 NOT NULL,
		  UNIQUE KEY id (id)
		   );";
	    require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
   		dbDelta( $sql );
    }
    
    /**
     * 
     * Purge cron and settings
     */
    public static function plugin_deactivation(){
    	//Do something (remove cron...)
    }
    
    /**
     * 
     * On plugin uninstallation
     */
    public static function plugin_uninstall(){
    	//May we remove plugin's options ...
    }
    
	/**
     * 
     * Add some new schedules
     * @param array $schedules
     */
    public static function custom_cron_schedules($schedules){
		//10 minutes, mainly for tests
		$schedules['10min'] = array(
			'interval'   => 60*10,// in seconds
			'display'   => __('Every 10 minutes','fbexppar'), 
		);
		
		return $schedules;
	}
	/***stat page ***/
	public static function admin_stat()
	{
	
		global $wpdb;

		$table = new Custom_Table_fbexppar_List_Table();
		$table->prepare_items();
	
		$message = '';
		if ('delete' === $table->current_action()) {
			$message = '<div class="updated below-h2" id="message"><p>' . sprintf(__('Items deleted: %d', 'custom_table_example'), count($_REQUEST['id'])) . '</p></div>';
		}
		?>
		<div class="wrap">
	
		<div class="icon32 icon32-posts-post" id="icon-edit"><br></div>
		
		<?php echo $message; ?>
	
		<form id="persons-table" method="GET">
			<input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>"/>
			<?php $table->display() ?>
		</form>
	
		</div>
	<?php
	}


	 
	public static function save_FBEXPPAR_stat($post_id,$url,$shares,$likes,$comments)
	 {
		 global $wpdb;
		 $table_name = $wpdb->prefix . "FBEXPPAR_stat";
		 $myPost = $wpdb->get_row($wpdb->prepare("SELECT * FROM ".$table_name ." WHERE post_id = %d",$post_id), ARRAY_N);
		 if (is_null($myPost))
		 {
			 $wpdb->insert( 
				$table_name, 
				array( 
				'post_id' => $post_id, 
				'url' => $url ,
				'shares' => $shares,
				'likes' => $likes,
				'comments' => $comments,
				'total_count'=> $comments+$likes+$shares
				), 
				array( 
				'%d', 
				'%s' ,
				'%d', 
				'%d', 
				'%d', 
				'%d' 
				) 
		
			);
		}
		else
		{
			$wpdb->update( 
				$table_name, 
				array( 
					'shares' => $shares,
					'likes' => $likes,
					'comments' => $comments,
					'total_count'=> $comments+$likes+$shares
				), 
				array( 'post_id' => $post_id ), 
				array( 
					'%d',	
					'%d',	
					'%s',	
					'%d'	
				), 
				array( '%d' ) 
			);
		}
	}
	
}

if (!class_exists('WP_List_Table')) {
    require_once(ABSPATH . 'wp-admin/includes/class-wp-list-table.php');
}
class Custom_Table_fbexppar_List_Table extends WP_List_Table
{
    function __construct()
    {
        global $status, $page;

        parent::__construct();
    }

    function column_default($item, $column_name)
    {
        return $item[$column_name];
    }

    function column_url($item)
    {
        return '<em><a href="'.$item['url'].'" target="_blank">' . $item['url'] . '</a></em>';
    }

    function column_post_id($item)
    {
        return sprintf('%d',$item['post_id']);
    }

    function column_cb($item)
    {
        return sprintf(
            '<input type="checkbox" name="id[]" value="%s" />',
            $item['id']
        );
    }

    function get_columns()
    {
        $columns = array(
            'cb' => '<input type="checkbox" />', //Render a checkbox instead of text
			'post_id' => 'Post Id',
            'url' => 'Url',
            'shares' => 'Shares',
			'likes' => 'likes',
			'cts' => 'Comments',
			'total_count' => 'Total count',
        );
        return $columns;
    }
    function get_sortable_columns()
    {
        $sortable_columns = array(
            'post_id' => array('post_id', false),
			'shares' => array('shares', true),
            'likes' => array('likes', true),
            'cts' => array('cts', true),
			'total_count' => array('total_count', true),
			
        );
        return $sortable_columns;
    }
    function get_bulk_actions()
    {
        $actions = array(
            'delete' => 'Delete'
        );
        return $actions;
    }
    function process_bulk_action()
    {
        global $wpdb;
       
	    $table_name = $wpdb->prefix . 'FBEXPPAR_stat'; 

        if ('delete' === $this->current_action()) {
            $ids = isset($_REQUEST['id']) ? $_REQUEST['id'] : array();
            if (is_array($ids)) $ids = implode(',', $ids);

            if (!empty($ids)) {
                $wpdb->query("DELETE FROM $table_name WHERE id IN($ids)");
            }
        }
		
    }

    function prepare_items()
    {
        global $wpdb;
        $table_name = $wpdb->prefix . 'FBEXPPAR_stat';

        $per_post = 10;

        $columns = $this->get_columns();
        $hidden = array();
        $sortable = $this->get_sortable_columns();

        $this->_column_headers = array($columns, $hidden, $sortable);

        $this->process_bulk_action();


        $total_items = $wpdb->get_var("SELECT COUNT(id) FROM $table_name");


        $paged = isset($_REQUEST['paged']) ? max(0, intval($_REQUEST['paged']) - 1) : 0;
        $orderby = (isset($_REQUEST['orderby']) && in_array($_REQUEST['orderby'], array_keys($this->get_sortable_columns()))) ? $_REQUEST['orderby'] : 'total_count';
        $order = (isset($_REQUEST['order']) && in_array($_REQUEST['order'], array('asc', 'desc'))) ? $_REQUEST['order'] : 'desc';

        $this->items = $wpdb->get_results($wpdb->prepare("SELECT id,post_id,url,shares,likes,comments as cts,total_count FROM $table_name ORDER BY $orderby $order LIMIT %d OFFSET %d", $per_post, $paged), ARRAY_A);


        $this->set_pagination_args(array(
            'total_items' => $total_items,
            'per_post' => $per_post, 
            'total_pages' => ceil($total_items / $per_post)
        ));
    }
}